<script lang="ts">
  import { getContext } from 'svelte'
  import { Character } from '../../../module/character/character.js'

  import { getLocalizer } from '../../../module/utils.js'
  import Dialog from '../../Dialog.svelte'
  import MeleeCombatRoll from '../../roll-dialog/MeleeCombatRoll.svelte'
  import Roll from '../../roll-dialog/Roll.svelte'
  import RangedCombatRoll from '../../roll-dialog/RangedCombatRoll.svelte'
  import { CharacterDataAccessor } from '../../../module/model/character.js'
  import { Writable } from 'svelte/store'
  import { Weapon } from '../../../module/model/items.js'

  const localize = getLocalizer()

  let doc = getContext<Writable<CharacterDataAccessor>>('doc')
  $: character = new Character($doc)

  $: availableOffensiveManeuvers = character.maneuverList('offensive', true)
  $: availableDefensiveManeuvers = character.maneuverList('defensive', true)

  let attackRollDialog
  let rangedAttackRollDialog
  let parryRollDialog

  function rollAttack(modifiers, _mod) {
    character.attack({ modifiers })
  }

  function rollParry(modifiers, _mod) {
    character.parry({ modifiers })
  }

  function rollRangedAttack(modifiers) {
    character.rangedAttack({ modifiers })
  }

  let damageRollDialog

  function rollDamage(modifiers) {
    character.rollDamage({
      modifiers,
    })
  }

  export let weapon: Weapon
  export let isSecondary = false
  export let isArmed = true
</script>

<Dialog
  bind:this={attackRollDialog}
  title={localize('maneuverEditor')}
  dialogComponent={MeleeCombatRoll}
  availableManeuvers={availableOffensiveManeuvers}
  {character}
  {weapon}
  callback={rollAttack}
  actionModifierCalculator={character.attackModifiers.bind(character)}
/>

<Dialog
  bind:this={parryRollDialog}
  title={localize('maneuverEditor')}
  dialogComponent={MeleeCombatRoll}
  availableManeuvers={availableDefensiveManeuvers}
  {character}
  {weapon}
  callback={rollParry}
  actionModifierCalculator={character.parryModifiers.bind(character)}
/>

<Dialog
  bind:this={rangedAttackRollDialog}
  title={localize('rangedAttack')}
  dialogComponent={RangedCombatRoll}
  {character}
  callback={rollRangedAttack}
/>

<Dialog
  bind:this={damageRollDialog}
  title={localize('damage')}
  dialogComponent={Roll}
  callback={rollDamage}
/>

<div class="weapon">
  <div class="combat-attribute-label" data-testid="combat-stat-label">
    {weapon.name}
  </div>
  <div class="combat-attributes flexrow">
    {#if weapon.type === 'meleeWeapon' || !isArmed}
      <!-- svelte-ignore a11y-click-events-have-key-events a11y-no-static-element-interactions a11y-missing-attribute -->
      <a
        title={localize('roll')}
        on:click={attackRollDialog.open}
        data-testid="attack-roll"
      >
        <div class="combat-attribute-label">
          <i class="fas fa-dice-d20" />
          {localize('attack')}
        </div>
        <div class="combat-attribute-value">
          {character.attackValue(isSecondary)}
        </div>
      </a>
      <!-- svelte-ignore a11y-click-events-have-key-events a11y-no-static-element-interactions a11y-missing-attribute -->
      <a
        title={localize('roll')}
        on:click={parryRollDialog.open}
        data-testid="parry-roll"
      >
        <div class="combat-attribute-label">
          <i class="fas fa-dice-d20" />
          {localize('parry')}
        </div>
        <div class="combat-attribute-value">
          {character.parryValue(isSecondary)}
        </div>
      </a>
    {/if}
    {#if weapon.type === 'rangedWeapon'}
      <!-- svelte-ignore a11y-click-events-have-key-events a11y-no-static-element-interactions a11y-missing-attribute -->
      <a
        title={localize('roll')}
        on:click={rangedAttackRollDialog.open}
        data-testid="ranged-attack-roll"
      >
        <div class="combat-attribute-label">
          <i class="fas fa-dice-d20" />
          {localize('rangedAttack')}
        </div>
        <div class="combat-attribute-value">
          {character.rangedAttackValue()}
        </div>
      </a>
    {/if}
    <div class="damage-roll">
      <!-- svelte-ignore a11y-click-events-have-key-events a11y-no-static-element-interactions a11y-missing-attribute -->
      <a
        title={localize('roll')}
        on:click={damageRollDialog.open}
        data-testid="damage-roll"
      >
        <div class="combat-attribute-label">
          <i class="fas fa-dice-d20" />
          {#if isArmed}
            {localize('hitPoints')}
          {:else}
            {localize('enduranceDamage')}
          {/if}
        </div>
        <div class="combat-attribute-value">
          {character.damage(isSecondary)}
        </div>
      </a>
    </div>
  </div>
</div>
